"use strict";
///<reference types="node"/>
Object.defineProperty(exports, "__esModule", { value: true });
exports.targetIndexFile = exports.IS_WINDOWS = exports.API_CONFIG_FILE = exports.DTS_CONFIG_FILE = exports.EXPORT_TEMP_PATH = exports.PROJECT_ROOT = exports.CONFIG_FILE = exports.SOURCE_ROOT = exports.NO_DUAL_FLAG = void 0;
const fs_1 = require("fs");
const os_1 = require("os");
const path_1 = require("path");
const findUp_1 = require("./findUp");
const paths_1 = require("./paths");
exports.NO_DUAL_FLAG = '--no-dual-package';
const item = process.argv[process.argv.length - 1] || '.';
const project = path_1.resolve(process.cwd(), item);
let configFilePath = '';
if (fs_1.existsSync(project)) {
    if (fs_1.existsSync(path_1.resolve(project, 'tsconfig.json'))) {
        configFilePath = path_1.resolve(project, 'tsconfig.json');
    }
    else if (fs_1.lstatSync(project).isFile()) {
        configFilePath = project;
    }
}
if (!configFilePath) {
    throw new Error('Cannot find tsconfig.json file: ' + project);
}
// modify this if some IDE supports other source root
exports.SOURCE_ROOT = path_1.resolve(configFilePath, '..');
exports.CONFIG_FILE = configFilePath;
const packageJsonFile = findUp_1.findUp(configFilePath, 'package.json');
if (!packageJsonFile) {
    throw new Error('Cannot find any package.json from tsconfig to root');
}
exports.PROJECT_ROOT = path_1.resolve(packageJsonFile, '..');
function getTemp() {
    if (process.env.RUSH_TEMP_FOLDER) {
        return process.env.RUSH_TEMP_FOLDER;
    }
    else {
        return os_1.tmpdir();
    }
}
exports.EXPORT_TEMP_PATH = path_1.resolve(getTemp(), 'export-all-in-one-working.' + (Math.random() * 1000000).toFixed(0) + '.tmp');
exports.DTS_CONFIG_FILE = path_1.resolve(exports.EXPORT_TEMP_PATH, 'tsconfig.json');
exports.API_CONFIG_FILE = path_1.resolve(exports.EXPORT_TEMP_PATH, 'api-extractor.json');
exports.IS_WINDOWS = os_1.platform() === 'win32';
exports.targetIndexFile = path_1.resolve(exports.EXPORT_TEMP_PATH, 'extracted-source', `${paths_1.INDEX_FILE_NAME}.ts`);
//# sourceMappingURL=argParse.js.map